2024.2.4力扣每日一题——Nim游戏

2024.2.4

题目来源

力扣每日一题;题序:292

我的题解

使用动态规划

方法一 数学规律

如果石头堆中只有一块、两块、或是三块石头,那么在你的回合,你就可以把全部石子拿走,从而在游戏中取胜;如果堆中恰好有四块石头,你就会失败。因为在这种情况下不管你取走多少石头,总会为你的对手留下几块,他可以将剩余的石头全部取完,从而他可以在游戏中打败你。因此,要想获胜,在你的回合中,必须避免石头堆中的石子数为 4 的情况。

  • 假设当前堆里只剩下五块、六块、或是七块石头,你可以控制自己拿取的石头数,总是恰好给你的对手留下四块石头,使他输掉这场比赛。但是如果石头堆里有八块石头,你就不可避免地会输掉,因为不管你从一堆石头中挑出一块、两块还是三块,你的对手都可以选择三块、两块或一块,以确保在再一次轮到你的时候,你会面对四块石头。显然我们继续推理,可以看到它会以相同的模式不断重复 n=4,8,12,16,...,基本可以看出如果堆里的石头数目为 4 的倍数时,你一定会输掉游戏。
  • 如果总的石头数目为 4 的倍数时,因为无论你取多少石头,对方总有对应的取法,让剩余的石头的数目继续为 4 的倍数。对于你或者你的对手取石头时,显然最优的选择是当前己方取完石头后,让剩余的石头的数目为 4 的倍数。假设当前的石头数目为 x,如果 x 为 4 的倍数时,则此时你必然会输掉游戏;如果 x 不为 4 的倍数时,则此时你只需要取走 x mod 4个石头时,则剩余的石头数目必然为 4 的倍数,从而对手会输掉游戏。
    时间复杂度 :O(1)
    空间复杂度:O(1)
java 复制代码
public boolean canWinNim(int n) {
    if(n<=3)
        return true;
    return n%4!=0;
}

有任何问题,欢迎评论区交流,欢迎评论区提供其它解题思路(代码),也可以点个赞支持一下作者哈😄~

相关推荐
weixin_3077791310 分钟前
C++代码实现MATLAB中的normalize函数功能
开发语言·c++·算法·matlab
不会就选b22 分钟前
算法日常・每日刷题--<动态规划>11
算法
(Charon)24 分钟前
【C++面试】手写String类:同时实现拷贝构造与移动构造
c++·算法
成旭先生26 分钟前
AI 文本审核 API:一段中文文本判风险等级、命中标签与处置建议
java·前端·人工智能·api接口·内容风控·文本审核·ugc审核
~~~45530 分钟前
Java 数组详细笔记
java
Jinkxs33 分钟前
Zookeeper - Java API 实现节点的创建与删除开发
java·zookeeper·java-zookeeper
liangshanbo121537 分钟前
前端面试题:AI 对话中超长消息导致内存溢出,怎么解决?
java·开发语言·前端
迷途之人不知返43 分钟前
算法系列6:模拟
算法
极客先躯1 小时前
高级java每日一道面试题-2026年01月20日-实战篇[Docker]-如何实现镜像的跨区域复制?
java·运维·docker·容器·架构图
旺仔仔仔1 小时前
# 机器人项目实战(1):选相机、试深度,再到手眼标定
算法